# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free

Name:           jackrabbit
Version:        1.4
Release:        1%{dist}
Epoch:          0
Summary:        Apache Jackrabbit JCR Implementation
License:        Apache Software License 2.0
Url:            http://jackrabbit.apache.org/
Group:          Development/Libraries/Application Frameworks
Source0:        http://www.apache.org/dist/jackrabbit/source/jackrabbit-1.4-src.jar

Source1:        jackrabbit-1.4-settings.xml
Source2:        jackrabbit-1.4-jpp-depmap.xml
Patch0:         jackrabbit-1.4-pom.patch
Patch1:         jackrabbit-1.4-spi-Batch.patch
Patch2:         jackrabbit-1.4-ocm-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel = 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-default-skin
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-one
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-surefire-plugin
BuildRequires:  mojo-maven2-plugin-build-helper
BuildRequires:  mojo-maven2-plugin-javacc
BuildRequires:  jetty6-maven2-plugins
BuildRequires:  junit
BuildRequires:  javacc3
BuildRequires:  derby
BuildRequires:  easymock

BuildRequires:  cglib
BuildRequires:  concurrent
BuildRequires:  jakarta-commons-beanutils
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-digester
BuildRequires:  jakarta-commons-httpclient
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-poi
BuildRequires:  j2ee_connector_1_5_api
BuildRequires:  jcr-1.0-api
BuildRequires:  jta_1_0_1B_api
BuildRequires:  log4j
BuildRequires:  lucene22
BuildRequires:  nekohtml
BuildRequires:  pdfbox
BuildRequires:  servletapi4
BuildRequires:  slf4j
BuildRequires:  textmining
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis

Requires:       cglib
Requires:       concurrent
Requires:       jakarta-commons-beanutils
Requires:       jakarta-commons-collections
Requires:       jakarta-commons-digester
Requires:       jakarta-commons-httpclient
Requires:       jakarta-commons-logging
Requires:       jakarta-poi
Requires:       j2ee_connector_1_5_api
Requires:       jcr-1.0-api
Requires:       jta_1_0_1B_api
Requires:       log4j
Requires:       lucene22
Requires:       nekohtml
Requires:       pdfbox
Requires:       servletapi4
Requires:       slf4j
Requires:       textmining
Requires:       xalan-j2
Requires:       xerces-j2
Requires:       xml-commons-jaxp-1.3-apis
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5


%description
The Jackrabbit Project has been formed to develop an open source 
implementation of the Content Repository for Java Technology API 
(JCR), being specified within the Java Community Process as 
JSR-170. Day Software, the JSR-170 specification lead, 
has licensed an initial implementation of the JCR reference 
implementation for use as seed code for this project. JCR 
specifies an API for application developers (and application 
frameworks) to use for interaction with modern content 
repositories that provide content services such as searching, 
versioning, transactions, etc. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

%description manual
%{summary}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q 
# remove all binary libs
#find . -name "*.jar" -exec rm -f {} \;
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2

%build
export JAVA_HOME=%{_jvmdir}/java-1.5.0

cp %{SOURCE1} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export MAVEN_OPTS="-Xmx512m"
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install 
pushd jackrabbit-ocm
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install javadoc:javadoc
popd
pushd jackrabbit-ocm-nodemanagement
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install javadoc:javadoc
popd
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        site javadoc:javadoc


%install
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

for m in \
         api \
         classloader \
         core \
         jca \
         jcr2spi \
         jcr-commons \
         jcr-rmi \
         jcr-server \
         jcr-servlet \
         jcr-tests \
         ocm \
         ocm-nodemanagement \
         spi2jcr \
         spi-commons \
         spi \
         text-extractors \
         webapp \
         webdav \
         ; do
    install -m 644 jackrabbit-${m}/target/jackrabbit-${m}-%{version}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/${m}-%{version}.jar
    install -m 644 jackrabbit-${m}/pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jackrabbit-${m}.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit-${m} %{version} JPP/%{name} ${m}
done

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -m 644 pom.xml \
        $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.jackrabbit-jackrabbit.pom
%add_to_maven_depmap org.apache.jackrabbit jackrabbit %{version} JPP/%{name} jackrabbit

install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* \
    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/ocm
cp -pr jackrabbit-ocm/target/site/apidocs/* \
    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/ocm
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/ocm-nodemanagement
cp -pr jackrabbit-ocm-nodemanagement/target/site/apidocs/* \
    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/ocm-nodemanagement

ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/site/apidocs

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%post
%update_maven_depmap

%postun
%update_maven_depmap


%files 
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{name}
%{_datadir}/maven2/poms
%{_mavendepmapfragdir}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Fri Jun 27 2008 Ralph Apel <r.apel at r-apel.de> 0:1.4-1.jpp5
- 1.4

* Mon Oct 24 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.r321061.2jpp
- Downgrade Requirement to spring11

* Wed Oct 19 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.r321061.1jpp
- First build from this codebase
